DATA
save_cacr:
ds.l 1

TEXT
SUPER
MC68030

EXPORT asm_save_030_cache_settings
EXPORT asm_deactivate_030_datacache
EXPORT asm_restore_030_cache_settings

asm_save_030_cache_settings:
movec cacr,d0
move.l d0,save_cacr
rts

asm_deactivate_030_datacache:
movec cacr,d0
bset #0,d0 ; i cache on
bset #4,d0 ; i burst on
bclr #8,d0 ; d cache off
bclr #12,d0 ; d burst off
movec d0,cacr
rts

asm_restore_030_cache_settings:
move.l save_cacr,d0
bset #11,d0 ; clear data cache
bset #3,d0 ; clear inst cache
movec d0,cacr
rts
END
